Index: trunk/include/functions_tag.inc.php
===================================================================
--- trunk/include/functions_tag.inc.php	(revision 1119)
+++ trunk/include/functions_tag.inc.php	(revision 1119)
@@ -0,0 +1,218 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | PhpWebGallery - a PHP based picture gallery                           |
+// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
+// | Copyright (C) 2003-2006 PhpWebGallery Team - http://phpwebgallery.net |
+// +-----------------------------------------------------------------------+
+// | branch        : BSF (Best So Far)
+// | file          : $RCSfile$
+// | last update   : $Date: 2006-03-16 23:58:16 +0100 (jeu, 16 mar 2006) $
+// | last modifier : $Author: rub $
+// | revision      : $Revision: 1085 $
+// | revision      : $Revision: 1085 $
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+
+/**
+ * Tags available. Each return tag is represented as an array with its id,
+ * its name, its weight (count), its url name. Tags are not sorted.
+ *
+ * The returned list can be a subset of all existing tags due to
+ * permissions, only if a list of forbidden categories is provided
+ *
+ * @param array forbidden categories
+ * @return array
+ */
+function get_available_tags($forbidden_categories = null)
+{
+  // we can find top fatter tags among reachable images
+  $tags_query = '
+SELECT tag_id, name, url_name, count(*) counter
+  FROM '.IMAGE_TAG_TABLE.'
+    INNER JOIN '.TAGS_TABLE.' ON tag_id = id';
+
+  if (!is_null($forbidden_categories))
+  {
+    // first we need all reachable image ids
+    $images_query = '
+SELECT DISTINCT image_id
+  FROM '.IMAGE_CATEGORY_TABLE.'
+  WHERE category_id NOT IN ('.implode(',', $forbidden_categories).')
+;';
+    $image_ids = array_from_query($images_query, 'image_id');
+
+    $tags_query.= '
+  WHERE image_id IN ('.
+      wordwrap(
+        implode(', ', $image_ids),
+        80,
+        "\n"
+        ).')';
+  }
+  
+  $tags_query.= '
+  GROUP BY tag_id
+;';
+
+  $result = pwg_query($tags_query);
+  
+  $tags = array();
+
+  while ($row = mysql_fetch_array($result))
+  {
+    array_push($tags, $row);
+  }
+
+  return $tags;
+}
+
+/**
+ * All tags, even tags associated to no image.
+ *
+ * @return array
+ */
+function get_all_tags()
+{
+  $query = '
+SELECT id AS tag_id, name, url_name
+  FROM '.TAGS_TABLE.'
+  ORDER BY name
+;';
+  $result = pwg_query($query);
+  
+  $tags = array();
+
+  while ($row = mysql_fetch_array($result))
+  {
+    array_push($tags, $row);
+  }
+
+  return $tags;
+}
+
+/**
+ * Giving a set of tags with a counter for each one, calculate the display
+ * level of each tag.
+ *
+ * The level of each tag depends on the average count of tags. This
+ * calcylation method avoid having very different levels for tags having
+ * nearly the same count when set are small.
+ *
+ * @param array tags
+ * @return array
+ */
+function add_level_to_tags($tags)
+{
+  global $conf;
+
+  if (count($tags) == 0)
+  {
+    return $tags;
+  }
+  
+  $total_count = 0;
+
+  foreach ($tags as $tag)
+  {
+    $total_count+= $tag['counter'];
+  }
+
+  // average count of available tags will determine the level of each tag
+  $tag_average_count = $total_count / count($tags);
+
+  // tag levels threshold calculation: a tag with an average rate must have
+  // the middle level.
+  for ($i = 1; $i < $conf['tags_levels']; $i++)
+  {
+    $threshold_of_level[$i] =
+      2 * $i * $tag_average_count / $conf['tags_levels'];
+  }
+
+  // display sorted tags
+  foreach (array_keys($tags) as $k)
+  {
+    $tags[$k]['level'] = 1;
+    
+    // based on threshold, determine current tag level
+    for ($i = $conf['tags_levels'] - 1; $i >= 1; $i--)
+    {
+      if ($tags[$k]['counter'] > $threshold_of_level[$i])
+      {
+        $tags[$k]['level'] = $i + 1;
+        break;
+      }
+    }
+  }
+
+  return $tags;
+}
+
+/**
+ * return the list of image ids corresponding to given tags. AND & OR mode
+ * supported.
+ *
+ * @param array tag ids
+ * @param string mode
+ * @return array
+ */
+function get_image_ids_for_tags($tag_ids, $mode = 'AND')
+{
+  switch ($mode)
+  {
+    case 'AND':
+    {
+      // strategy is to list images associated to each tag
+      $tag_images = array();
+      
+      foreach ($tag_ids as $tag_id)
+      {
+        $query = '
+SELECT image_id
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE tag_id = '.$tag_id.'
+;';
+        $tag_images[$tag_id] = array_from_query($query, 'image_id');
+      }
+
+      // then we calculate the intersection, the images that are associated to
+      // every tags
+      $items = array_shift($tag_images);
+      foreach ($tag_images as $images)
+      {
+        $items = array_intersect($items, $images);
+      }
+
+      return array_unique($items);
+      break;
+    }
+    case 'OR':
+    {
+      $query = '
+SELECT DISTINCT image_id
+  FROM '.IMAGE_TAG_TABLE.'
+  WHERE tag_id IN ('.implode(',', $tag_ids).')
+;';
+      return array_from_query($query, 'image_id');
+      break;
+    }
+    default:
+    {
+      die('get_image_ids_for_tags: unknown mode, only AND & OR are supported');
+    }
+  }
+}
+?>
Index: trunk/include/functions_url.inc.php
===================================================================
--- trunk/include/functions_url.inc.php	(revision 1118)
+++ trunk/include/functions_url.inc.php	(revision 1119)
@@ -259,26 +259,21 @@
   $section_string = '';
 
+  $section_of = array(
+    'category' => 'categories',
+    'tags'     => 'tags',
+    'list'     => 'list',
+    'search'   => 'search',
+    );
+
+  foreach ($section_of as $param => $section)
+  {
+    if (isset($params[$param]))
+    {
+      $params['section'] = $section;
+    }
+  }
+
   if (!isset($params['section']))
   {
-    if (isset($params['category']))
-    {
-      $params['section'] = 'categories';
-    }
-    else if (isset($params['tags']))
-    {
-      $params['section'] = 'tags';
-    }
-    else if (isset($params['list']))
-    {
-      $params['section'] = 'list';
-    }
-    else if (isset($params['search']))
-    {
-      $params['section'] = 'search';
-    }
-  }
-
-  if (!isset($params['section']))
-  {
     $params['section'] = 'categories';
   }
@@ -290,5 +285,5 @@
       if (!isset($params['category']))
       {
-        //$section_string.= '/categories';
+        $section_string.= '/categories';
       }
       else
@@ -310,5 +305,10 @@
       foreach ($params['tags'] as $tag)
       {
-        $section_string.= '/'.$tag;
+        $section_string.= '/'.$tag['id'];
+        
+        if (isset($tag['url_name']))
+        {
+          $section_string.= '-'.$tag['url_name'];
+        }
       }
 
Index: trunk/include/section_init.inc.php
===================================================================
--- trunk/include/section_init.inc.php	(revision 1118)
+++ trunk/include/section_init.inc.php	(revision 1119)
@@ -146,13 +146,9 @@
 
   $next_token++;
-
-  for ($i = $next_token; ; $i++)
-  {
-    if (!isset($tokens[$i]))
-    {
-      break;
-    }
-
-    preg_match('/^(\d+)/', $tokens[$i], $matches);
+  $i = $next_token;
+
+  while (isset($tokens[$i]))
+  {
+    preg_match('/^(\d+)(?:-(.*))?/', $tokens[$i], $matches);
     if (!isset($matches[1]))
     {
@@ -166,5 +162,14 @@
       }
     }
-    array_push($page['tags'], $matches[1]);
+    
+    array_push(
+      $page['tags'],
+      array(
+        'id'       => $matches[1],
+        'url_name' => isset($matches[2]) ? $matches[2] : '',
+        )
+      );
+
+    $i++;
   }
 
@@ -226,11 +231,8 @@
 }
 
-for ($i = $next_token; ; $i++)
-{
-  if (!isset($tokens[$i]))
-  {
-    break;
-  }
-
+$i = $next_token;
+
+while (isset($tokens[$i]))
+{
   if (preg_match('/^start-(\d+)/', $tokens[$i], $matches))
   {
@@ -241,7 +243,10 @@
   {
     $chronology_tokens = explode('-', $tokens[$i] );
+
     $page['chronology_field'] = $chronology_tokens[0];
+
     array_shift($chronology_tokens);
     $page['chronology_style'] = $chronology_tokens[0];
+
     array_shift($chronology_tokens);
     if ( count($chronology_tokens)>0 )
@@ -256,4 +261,6 @@
     }
   }
+
+  $i++;
 }
 
@@ -339,4 +346,81 @@
   }
 // +-----------------------------------------------------------------------+
+// |                            tags section                               |
+// +-----------------------------------------------------------------------+
+  if ($page['section'] == 'tags')
+  {
+    $page['tag_ids'] = array();
+    foreach ($page['tags'] as $tag)
+    {
+      array_push($page['tag_ids'], $tag['id']);
+    }
+
+    $items = get_image_ids_for_tags($page['tag_ids']);
+
+    // permissions depends on category, so to only keep images that are
+    // reachable to the connected user, we need to check category
+    // associations
+    if (!empty($user['forbidden_categories']))
+    {
+      $query = '
+SELECT image_id
+  FROM '.IMAGE_CATEGORY_TABLE.'
+  WHERE image_id IN ('.implode(',', $items).')
+    AND '.$forbidden.'
+;';
+      $items = array_unique(
+        array_from_query($query, 'image_id')
+        );
+    }
+
+    // tag names
+    $query = '
+SELECT name, url_name, id
+  FROM '.TAGS_TABLE.'
+  WHERE id IN ('.implode(',', $page['tag_ids']).')
+;';
+    $result = pwg_query($query);
+    $tag_infos = array();
+    
+    while ($row = mysql_fetch_array($result))
+    {
+      $tag_infos[ $row['id'] ]['name'] = $row['name'];
+      $tag_infos[ $row['id'] ]['url_name'] = $row['url_name'];
+    }
+
+    $title = count($page['tags']) > 1 ? l10n('Tags') : l10n('Tag');
+    $title.= ' ';
+
+    $tag_num = 1;
+    foreach ($page['tag_ids'] as $tag_id)
+    {
+      $title.=
+        ($tag_num++ > 1 ? ' + ' : '')
+        .'<a href="'
+        .make_index_url(
+          array(
+            'tags' => array(
+              array(
+                'id' => $tag_id,
+                'url_name' => $tag_infos[$tag_id]['url_name'],
+                ),
+              )
+            )
+          )
+        .'">'
+        .$tag_infos[$tag_id]['name']
+        .'</a>';
+    }
+
+    $page = array_merge(
+      $page,
+      array(
+        'title' => $title,
+        'items' => array_values($items),
+        'thumbnails_include' => 'include/category_default.inc.php',
+        )
+      );
+  }
+// +-----------------------------------------------------------------------+
 // |                           search section                              |
 // +-----------------------------------------------------------------------+
@@ -344,12 +428,13 @@
   {
     include_once( PHPWG_ROOT_PATH .'include/functions_search.inc.php' );
+
     $query = '
 SELECT DISTINCT(id)
   FROM '.IMAGES_TABLE.'
     INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON id = ic.image_id
-  WHERE '.get_sql_search_clause($page['search']).'
+  WHERE id IN ('.implode(',', get_search_items($page['search'])).')
     AND '.$forbidden.'
   '.$conf['order_by'].'
-;';
+;'; 
 
     $page = array_merge(
Index: trunk/index.php
===================================================================
--- trunk/index.php	(revision 1118)
+++ trunk/index.php	(revision 1119)
@@ -222,4 +222,74 @@
   }
 }
+//------------------------------------------------------------------------ tags
+if ('tags' == $page['section'])
+{
+  $template->assign_block_vars('tags', array());
+  
+  // display tags associated to currently tagged items, less current tags
+  $query = '
+SELECT tag_id, name, url_name, count(*) counter
+  FROM '.IMAGE_TAG_TABLE.'
+    INNER JOIN '.TAGS_TABLE.' ON tag_id = id
+  WHERE image_id IN ('.implode(',', $items).')
+    AND tag_id NOT IN ('.implode(',', $page['tag_ids']).')
+  GROUP BY tag_id
+  ORDER BY name ASC
+;';
+  $result = pwg_query($query);
+
+  $tags = array();
+  
+  while($row = mysql_fetch_array($result))
+  {
+    array_push($tags, $row);
+  }
+
+  $tags = add_level_to_tags($tags);
+
+  foreach ($tags as $tag)
+  {
+    $template->assign_block_vars(
+      'tags.tag',
+      array(
+        'URL_ADD' => make_index_URL(
+          array(
+            'tags' => array_merge(
+              $page['tags'],
+              array(
+                array(
+                  'id' => $tag['tag_id'],
+                  'url_name' => $tag['url_name'],
+                  ),
+                )
+              )
+            )
+          ),
+
+        'URL' => make_index_URL(
+          array(
+            'tags' => array(
+              array(
+                'id' => $tag['tag_id'],
+                'url_name' => $tag['url_name'],
+                ),
+              )
+            )
+          ),
+        
+        'NAME' => $tag['name'],
+        
+        'TITLE' => l10n('See pictures linked to this tag only'),
+
+        'TITLE_ADD' => sprintf(
+          l10n('%d pictures are also linked to current tags'),
+          $tag['counter']
+          ),
+        
+        'CLASS' => 'tagLevel'.$tag['level']
+        )
+      );
+  }
+}
 //---------------------------------------------------------- special categories
 // favorites categories
@@ -333,4 +403,14 @@
 }
 
+// tags link
+$template->assign_block_vars(
+  'summary',
+  array(
+    'TITLE' => l10n('See available tags'),
+    'NAME' => l10n('Tags'),
+    'U_SUMMARY'=> get_root_url().'tags.php',
+    )
+  );
+
 // search link
 $template->assign_block_vars(
Index: trunk/install/db/19-database.php
===================================================================
--- trunk/install/db/19-database.php	(revision 1119)
+++ trunk/install/db/19-database.php	(revision 1119)
@@ -0,0 +1,151 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | PhpWebGallery - a PHP based picture gallery                           |
+// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
+// | Copyright (C) 2003-2005 PhpWebGallery Team - http://phpwebgallery.net |
+// +-----------------------------------------------------------------------+
+// | branch        : BSF (Best So Far)
+// | file          : $RCSfile$
+// | last update   : $Date: 2005-09-21 00:04:57 +0200 (mer, 21 sep 2005) $
+// | last modifier : $Author: plg $
+// | revision      : $Revision: 870 $
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+if (!defined('PHPWG_ROOT_PATH'))
+{
+  die('Hacking attempt!');
+}
+
+$upgrade_description = '#images.keywords moved to new table #tags';
+
+// +-----------------------------------------------------------------------+
+// |                              New tables                               |
+// +-----------------------------------------------------------------------+
+
+$query = '
+CREATE TABLE '.PREFIX_TABLE.'tags (
+  id smallint(5) UNSIGNED NOT NULL auto_increment,
+  name varchar(255) BINARY NOT NULL,
+  url_name varchar(255) BINARY NOT NULL,
+  PRIMARY KEY (id)
+) TYPE=MyISAM
+;';
+pwg_query($query);
+
+$query = '
+CREATE TABLE '.PREFIX_TABLE.'image_tag (
+  image_id mediumint(8) UNSIGNED NOT NULL,
+  tag_id smallint(5) UNSIGNED NOT NULL,
+  PRIMARY KEY (image_id,tag_id)
+) TYPE=MyISAM
+;';
+pwg_query($query);
+
+// +-----------------------------------------------------------------------+
+// |                        Move keywords to tags                          |
+// +-----------------------------------------------------------------------+
+
+// each tag label is associated to a numeric identifier
+$tag_id = array();
+// to each tag id (key) a list of image ids (value) is associated
+$tag_images = array();
+
+$current_id = 1;
+
+$query = '
+SELECT id, keywords
+  FROM '.PREFIX_TABLE.'images
+  WHERE keywords IS NOT NULL
+;';
+$result = pwg_query($query);
+while ($row = mysql_fetch_array($result))
+{
+  foreach(preg_split('/[,]+/', $row['keywords']) as $keyword)
+  {
+    if (!isset($tag_id[$keyword]))
+    {
+      $tag_id[$keyword] = $current_id++;
+    }
+    
+    if (!isset($tag_images[ $tag_id[$keyword] ]))
+    {
+      $tag_images[ $tag_id[$keyword] ] = array();
+    }
+
+    array_push($tag_images[ $tag_id[$keyword] ], $row['id']);
+  }
+}
+
+$datas = array();
+foreach ($tag_id as $tag_name => $tag_id)
+{
+  array_push(
+    $datas,
+    array(
+      'id'       => $tag_id,
+      'name'     => $tag_name,
+      'url_name' => str2url($tag_name),
+      )
+    );
+}
+mass_inserts(
+  PREFIX_TABLE.'tags',
+  array_keys($datas[0]),
+  $datas
+  );
+
+$datas = array();
+foreach ($tag_images as $tag_id => $images)
+{
+  foreach (array_unique($images) as $image_id)
+  {
+    array_push(
+      $datas,
+      array(
+        'tag_id'   => $tag_id,
+        'image_id' => $image_id,
+        )
+      );
+  }
+}
+
+mass_inserts(
+  PREFIX_TABLE.'image_tag',
+  array_keys($datas[0]),
+  $datas
+  );
+
+// +-----------------------------------------------------------------------+
+// |                         Delete images.keywords                        |
+// +-----------------------------------------------------------------------+
+
+$query = '
+ALTER TABLE '.PREFIX_TABLE.'images DROP COLUMN keywords
+;';
+pwg_query($query);
+
+// +-----------------------------------------------------------------------+
+// |                           End notification                            |
+// +-----------------------------------------------------------------------+
+
+echo
+"\n"
+.'Table '.PREFIX_TABLE.'tags created and filled'."\n"
+.'Table '.PREFIX_TABLE.'image_tag created and filled'."\n"
+.'Column '.PREFIX_TABLE.'images.keywords dropped'."\n"
+;
+?>
Index: trunk/install/phpwebgallery_structure.sql
===================================================================
--- trunk/install/phpwebgallery_structure.sql	(revision 1118)
+++ trunk/install/phpwebgallery_structure.sql	(revision 1119)
@@ -1,3 +1,2 @@
--- MySQL dump 9.11
 -- MySQL dump 9.11
 --
@@ -147,4 +146,15 @@
 
 --
+-- Table structure for table `phpwebgallery_image_tag`
+--
+
+DROP TABLE IF EXISTS `phpwebgallery_image_tag`;
+CREATE TABLE `phpwebgallery_image_tag` (
+  `image_id` mediumint(8) unsigned NOT NULL default '0',
+  `tag_id` smallint(5) unsigned NOT NULL default '0',
+  PRIMARY KEY  (`image_id`,`tag_id`)
+) TYPE=MyISAM;
+
+--
 -- Table structure for table `phpwebgallery_images`
 --
@@ -164,6 +174,4 @@
   `width` smallint(9) unsigned default NULL,
   `height` smallint(9) unsigned default NULL,
-  `keywords` varchar(255) default NULL,
-  `storage_category_id` smallint(5) unsigned default NULL,
   `representative_ext` varchar(4) default NULL,
   `date_metadata_update` date default NULL,
@@ -173,5 +181,4 @@
   PRIMARY KEY  (`id`),
   KEY `images_i2` (`date_available`),
-  KEY `images_i1` (`storage_category_id`),
   KEY `images_i3` (`average_rate`),
   KEY `images_i4` (`hit`),
@@ -230,4 +237,16 @@
 
 --
+-- Table structure for table `phpwebgallery_tags`
+--
+
+DROP TABLE IF EXISTS `phpwebgallery_tags`;
+CREATE TABLE `phpwebgallery_tags` (
+  `id` smallint(5) unsigned NOT NULL auto_increment,
+  `name` varchar(255) binary NOT NULL default '',
+  `url_name` varchar(255) binary NOT NULL default '',
+  PRIMARY KEY  (`id`)
+) TYPE=MyISAM;
+
+--
 -- Table structure for table `phpwebgallery_upgrade`
 --
@@ -261,5 +280,5 @@
   `need_update` enum('true','false') NOT NULL default 'true',
   `forbidden_categories` text,
-  `nb_total_images` mediumint(8) unsigned,
+  `nb_total_images` mediumint(8) unsigned default NULL,
   PRIMARY KEY  (`user_id`)
 ) TYPE=MyISAM;
@@ -297,5 +316,5 @@
   `nb_image_line` tinyint(1) unsigned NOT NULL default '5',
   `nb_line_page` tinyint(3) unsigned NOT NULL default '3',
-  `status` enum('webmaster', 'admin', 'normal', 'generic', 'guest') NOT NULL default 'guest',
+  `status` enum('webmaster','admin','normal','generic','guest') NOT NULL default 'guest',
   `adviser` enum('true','false') NOT NULL default 'false',
   `language` varchar(50) NOT NULL default 'english',
